JsonCpp project page | Classes | Namespace | JsonCpp home page

Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
Json::CharReaderBuilder Class Reference

Build a CharReader implementation. More...

`#include <json/reader.h>`

Inheritance diagram for Json::CharReaderBuilder:
Collaboration diagram for Json::CharReaderBuilder:

## Public Member Functions
| CharReaderBuilder ()
| ~CharReaderBuilder ()
CharReader * | newCharReader () const
| Allocate a CharReader via operator new(). More...
bool | validate (Json::Value *invalid) const
Value & | operator[] (std::string key)
| A simple way to update a specific setting. More...
Public Member Functions inherited from Json::CharReader::Factory
virtual | ~Factory ()

## Static Public Member Functions
static void | setDefaults (Json::Value *settings)
| Called by ctor, but you can use this to reset settings_. More...
static void | strictMode (Json::Value *settings)
| Same as old Features::strictMode(). More...

## Public Attributes
Json::Value | settings_
| Configuration of this builder. More...

## Detailed Description

Build a CharReader implementation.

Usage:

using namespace Json;
CharReaderBuilder builder;
builder["collectComments"] = false;
Value value;
JSONCPP_STRING errs;
bool ok = parseFromStream(builder, std::cin, &value, &errs);

Definition at line 298 of file reader.h.

## Constructor & Destructor Documentation

## ◆ CharReaderBuilder()

Json::CharReaderBuilder::CharReaderBuilder | ( |  | ) |

Definition at line 1945 of file json_reader.cpp.

## ◆ ~CharReaderBuilder()

Json::CharReaderBuilder::~CharReaderBuilder | ( |  | ) |

Definition at line 1949 of file json_reader.cpp.

## Member Function Documentation

## ◆ newCharReader()

CharReader * Json::CharReaderBuilder::newCharReader | ( |  | ) | const
| virtual

Allocate a CharReader via operator new().

Exceptions

  std::exception | if something goes wrong (e.g. invalid settings)

Implements Json::CharReader::Factory.

Definition at line 1951 of file json_reader.cpp.

## ◆ operator[]()

Value & Json::CharReaderBuilder::operator[] | ( | std::string | key | ) |

A simple way to update a specific setting.

Definition at line 1997 of file json_reader.cpp.

## ◆ setDefaults()

void Json::CharReaderBuilder::setDefaults | ( | Json::Value * | settings | ) |
| static

Called by ctor, but you can use this to reset settings_.

Precondition
  'settings' != NULL (but Json::null is fine)

Remarks
  Defaults:
  (*settings)["collectComments"] = true;
  (*settings)["allowComments"] = true;
  (*settings)["strictRoot"] = false;
  (*settings)["allowDroppedNullPlaceholders"] = false;
  (*settings)["allowNumericKeys"] = false;
  (*settings)["allowSingleQuotes"] = false;
  (*settings)["stackLimit"] = 1000;
  (*settings)["failIfExtra"] = false;
  (*settings)["rejectDupKeys"] = false;
  (*settings)["allowSpecialFloats"] = false;

[CharReaderBuilderDefaults]

[CharReaderBuilderDefaults]

Definition at line 2017 of file json_reader.cpp.

## ◆ strictMode()

void Json::CharReaderBuilder::strictMode | ( | Json::Value * | settings | ) |
| static

Same as old Features::strictMode().

Precondition
  'settings' != NULL (but Json::null is fine)

Remarks
  Defaults:
  (*settings)["allowComments"] = false;
  (*settings)["strictRoot"] = true;
  (*settings)["allowDroppedNullPlaceholders"] = false;
  (*settings)["allowNumericKeys"] = false;
  (*settings)["allowSingleQuotes"] = false;
  (*settings)["stackLimit"] = 1000;
  (*settings)["failIfExtra"] = true;
  (*settings)["rejectDupKeys"] = true;
  (*settings)["allowSpecialFloats"] = false;

[CharReaderBuilderStrictMode]

[CharReaderBuilderStrictMode]

Definition at line 2002 of file json_reader.cpp.

## ◆ validate()

bool Json::CharReaderBuilder::validate | ( | Json::Value * | invalid | ) | const

Returns
  true if 'settings' are legal and consistent; otherwise, indicate bad settings via 'invalid'.

Definition at line 1980 of file json_reader.cpp.

References Json::getValidReaderKeys(), JSONCPP_STRING, and Json::Value::size().

## Member Data Documentation

## ◆ settings_

Json::Value Json::CharReaderBuilder::settings_

Configuration of this builder.

These are case-sensitive. Available settings (case-sensitive):

- `"collectComments": false or true`
  - true to collect comment and allow writing them back during serialization, false to discard comments. This parameter is ignored if allowComments is false.
- `"allowComments": false or true`
  - true if comments are allowed.
- `"strictRoot": false or true`
  - true if root must be either an array or an object value
- `"allowDroppedNullPlaceholders": false or true`
  - true if dropped null placeholders are allowed. (See StreamWriterBuilder.)
- `"allowNumericKeys": false or true`
  - true if numeric object keys are allowed.
- `"allowSingleQuotes": false or true`
  - true if '' are allowed for strings (both keys and values)
- `"stackLimit": integer`
  - Exceeding stackLimit (recursive depth of `readValue()`) will cause an exception.
  - This is a security issue (seg-faults caused by deeply nested JSON), so the default is low.
- `"failIfExtra": false or true`
  - If true, `parse()` returns false when extra non-whitespace trails the JSON value in the input string.
- `"rejectDupKeys": false or true`
  - If true, `parse()` returns false when a key is duplicated within an object.
- `"allowSpecialFloats": false or true`
  - If true, special float values (NaNs and infinities) are allowed and their values are lossfree restorable.

You can examine 'settings_` yourself to see the defaults. You can also write and read them just like any JSON Value.

See also
  setDefaults()

Definition at line 338 of file reader.h.

The documentation for this class was generated from the following files:

- include/json/reader.h
- src/lib_json/json_reader.cpp